 --A message from TheOuterLinux (https://theouterlinux.gitlab.io):

 --The original version of this file and its assets come from
 --https://github.com/kyleschaub/snippets/tree/main/love2d/3_animations
 
 --This version you see here was last updated on 2022/10/22
 
 --HOWEVER, in order to get it working with LoveDOS, some edits needed
 --to be made. For example, you cannot use "setDefaultFilter", to which
 --was left as a comment so as to be used on newer systems. Also, the
 --player position and speed needed to be changed because of DOS screen-
 --sizes. And one other thing to keep in mind, filenames still adhere to
 --the 8-character limit.
 
 --The player.grid parts refer to ...('FirstColumn#-LastColumn#', row), fps)
 
 --Maybe one of these days someone will come up with LUA script for
 --animated GIF's that also works in LoveDOS, but the old-school
 --sprite-sheet method is how you will have to create animations for the
 --moment.

function love.load()
    anim8 = require 'LIB/anim8'
    -- love.graphics.setDefaultFilter("nearest", "nearest")

    player = {}
    player.x = 100 -- set to 400 on a newer system
    player.y = 100 -- set to 200 on a newer system
    player.speed = .2 -- set to 5 on a newer system
    player.spriteSheet = love.graphics.newImage('SPRITES/PLAYER.PNG')
    player.grid = anim8.newGrid( 12, 18, player.spriteSheet:getWidth(), player.spriteSheet:getHeight() )

    player.animations = {}
    player.animations.down = anim8.newAnimation( player.grid('1-4', 1), 0.2 )
    player.animations.left = anim8.newAnimation( player.grid('1-4', 2), 0.2 )
    player.animations.right = anim8.newAnimation( player.grid('1-4', 3), 0.2 )
    player.animations.up = anim8.newAnimation( player.grid('1-4', 4), 0.2 )

    player.anim = player.animations.left

    background = love.graphics.newImage('SPRITES/BKGROUND.GIF')
end

function love.update(dt)
    local isMoving = false

    if love.keyboard.isDown("right") then
        player.x = player.x + player.speed
        player.anim = player.animations.right
        isMoving = true
    end

    if love.keyboard.isDown("left") then
        player.x = player.x - player.speed
        player.anim = player.animations.left
        isMoving = true
    end

    if love.keyboard.isDown("down") then
        player.y = player.y + player.speed
        player.anim = player.animations.down
        isMoving = true
    end

    if love.keyboard.isDown("up") then
        player.y = player.y - player.speed
        player.anim = player.animations.up
        isMoving = true
    end
    
    if love.keyboard.isDown("q") then
        love.event.quit()
    end

    if isMoving == false then
        player.anim:gotoFrame(2)
    end

    player.anim:update(dt)
end

function love.draw()
    love.graphics.draw(background, 0, 0)
    player.anim:draw(player.spriteSheet, player.x, player.y, nil, 10)
end
